# OB - Framework to program bots
#
# ob/cmds/clock.py
#
# Copyright 2017,2018 B.H.J Thate
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice don't have to be included.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# 13-07-2018 As the creator of this file, I disclaim all rights on  this file. 
#
# Bart Thate
# Heerhugowaard
# The Netherlands

""" timer, repeater. timed daemon. """

__version__ = 1

## imports

from ob.clock import Timed
from ob.utils import elapsed
from ob.utils.clock import get_time, today 
from ob.utils.rss import to_time

import time

## defines

_begintime = time.time()

## commands

def begin(event):
    global _begintime
    t = today()
    _begintime = t
    event.reply("time is %s" % time.ctime(t))

def end(event):
    global _begintime
    diff = time.time() - _begintime
    if diff:
        event.reply("time elapsed is %s" % elapsed(diff))

def timer(event):
    try:
        target = get_time(event.txt)
    except ValueError:
        return
    t = Timed()
    t.services = "clock"
    t.prefix = "timer"
    t.txt = event.rest
    t.time = target
    t.done = False
    t.save()
    event.reply("ok %s" % (time.ctime(target)))
