# OB - Framework to program bots
#
# ob/cmds/entry.py
#
# Copyright 2017,2018 B.H.J Thate
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy 
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights 
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
# copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice don't have to be included.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
# THE SOFTWARE.
#
# 06-04-2018 As the creator of this file, I disclaim all rights on this file. 
#
# Bart Thate
# Heerhugowaard
# The Netherlands

""" entry module. """

__version__ = 1

## imports 

from ob import workdir
from ob.db import Db
from ob.entry import *

import functools

## instances

db = Db()

## commands

def monday(event):
    """ monday <txt> - things to remember for monday. """
    o = Monday()
    o.txt = event.rest
    o.save()
    event.ok()

def tuesday(event):
    """ tuesday <txt> - things todo on tuesday. """
    o = Tuesday()
    o.txt = event.rest
    o.save()
    event.ok()

def wednesday(event):
    """ wednesday <txt> - things todo on the wednesday. """
    o = Wednesday()
    o.txt = event.rest
    o.save()
    event.ok()

def thursday(event):
    """ thursday <txt> - thursday activities. """
    o = Thursday()
    o.txt = event.rest
    o.save()
    event.ok()

def friday(event):
    """ friday <txt> - things to remember for friday. """
    o = Friday()
    o.txt = event.rest
    o.save()
    event.ok()

def saturday(event):
    """ saturday <txt> - things todo on the saturday. """
    o = Saturday()
    o.txt = event.rest
    o.save()
    event.ok()

def sunday(event):
    """ sunday <txt> - things todo on a sunday. """
    o = Sunday()
    o.txt = event.rest
    o.save()
    event.ok()

def holiday(event):
    """ holiday <txt> - remember things todo during the holidays. """
    o = Holiday()
    o.txt = event.rest
    o.save()
    event.ok()

def house(event):
    """ house <txt> - remember things todo around the house. """
    o = House()
    o.txt = event.rest
    o.save()
    event.ok()

def log(event):
    """ log <txt> - log some text. """
    o = Log()
    o.txt = event.rest
    o.save()
    event.ok()

def shop(event):
    """ shop <txt> - save a shop item. """
    o = Shop()
    o.txt = event.rest
    o.save()
    event.ok()

def todo(event):
    """ todo <txt> - save a todo item. """
    o = Todo()
    o.txt = event.rest
    o.save()
    event.ok()
