# OB - Framework to program bots
#
# ob/cmds/loader.py
#
# Copyright 2017,2018 B.H.J Thate
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy 
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights 
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
# copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice don't have to be included.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
# THE SOFTWARE.
#
# 13-07-2018 As the creator of this file, I disclaim all rights on this file. 
#
# Bart Thate
# Heerhugowaard
# The Netherlands

""" a loader is an object that can load modules. """

__version__ = 1

## imports

from ob.fleet import Fleet
from ob.shell import set_completer

## instances

fleet = Fleet()

## commands.

def load(event):
    bot = fleet.get_bot(event.orig)
    if not event.args:
        event.reply("load ob.[%s]" % ",".join([x.split(".")[-1] for x in sorted(bot.list("ob"))]))
        return
    name = event.args[0]
    try:
        bot.walk(name, True)
    except ModuleNotFoundError as ex:
        event.reply(ex.msg.lower()) 
    set_completer(sorted(bot.handlers.keys()))
    event.reply("%s loaded" % name)

def unload(event):
    bot = fleet.get_bot(event.orig)
    if not event.args:
        event.reply("unload ob.[%s]" % ",".join([x.split(".")[-1] for x in sorted(bot.table.keys())]))
        return
    name = event.args[0]
    if name == "ob.cmds":
        event.reply("can't unload ob.cmds")
        return
    try:
        bot.unload(name)
    except KeyError:
        event.reply("%s is not unloadable." % name)
        return
    set_completer(sorted(bot.keys()))
    event.reply("%s unloaded" % name)
