# OB - Framework to program bots
#
# ob/email.py
#
# Copyright 2017,2018 B.H.J Thate
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy 
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights 
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
# copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice don't have to be included.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
# THE SOFTWARE.
#
# 16-07-2018 As the creator of this file, I disclaim all rights on this file. 
#
# Bart Thate
# Heerhugowaard
# The Netherlands

""" email definitiions and commands """

## imports

from ob import starttime
from ob.fleet import Fleet
from ob.thr import Launcher
from ob.cmds.loader import unload
from ob.shell import reset
from ob.utils import elapsed

import ob
import os
import sys
import time
import _thread

## instances

launcher = Launcher()
fleet = Fleet()

## commands

def exit(event):
    _thread.interrupt_main()

def kill(event):
    if not event.args:
        event.reply("kill <match>")
        return
    n = event.args[0]
    launcher.kill(n)
    event.reply("ok %s" % n)

def reboot(event):
    fleet.announce("reboot %s" % time.ctime(time.time()))
    fleet.save()
    time.sleep(2.0)
    reset()
    os.execl(sys.argv[0], *sys.argv)

def uptime(event):
    event.reply("uptime is %s" % elapsed(time.time() - starttime))

def version(event):
    event.reply("OB #%s - Framework to progam bots" % ob.__version__)
