# OB - Framework to program bots
#
# ob/users.py
#
# Copyright 2017,2018 B.H.J Thate
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy 
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights 
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
# copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice don't have to be included.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
# THE SOFTWARE.
#
# 25-06-2018 As the creator of this file, I disclaim all rights on this file. 
#
# Bart Thate
# Heerhugowaard
# The Netherlands

""" register an user and give them USER or OPER permission. """

__version__ = 1

## imports

from ob.users import Users

## instances

users = Users()

## commands

def meet(event):
    try:
        origin, *perms = event.args
    except ValueError:
        return
    origin = users.userhosts.get(origin, origin)
    if users.meet(origin, perms):
        event.reply("%s added." % origin)

def perm(event):
    try:
        origin, *perms = event.args
    except ValueError:
        return
    users.users.last()
    origin = users.userhosts.get(origin, origin)
    for perm in perms:
        u = users.perm(origin, perm)
        if u:
            event.reply("ok %s" % origin)

def rmperm(event):
    try:
        origin, perm = event.args
    except:
        return
    origin = users.userhosts.get(origin, origin)
    result = users.delete(origin, perm)
    if not result:
        return
    event.reply("ok %s %s" % (origin, perm))

def user(event):
    if not event.args:
        return
    origin = event.args[0]
    origin = users.userhosts.get(origin, origin)
    u = users.users.get(origin, None)
    event.reply(u)
